/**
 * 
 */
package de.unibi.airobots.bonsai.skills;

import java.net.URISyntaxException;
import java.util.HashMap;
import java.util.Set;

import org.apache.log4j.Logger;

import de.unibi.airobots.bonsai.core.Actuator;
import de.unibi.airobots.bonsai.core.BonsaiManager;
import de.unibi.airobots.bonsai.core.BonsaiManager.ConfigurationException;
import de.unibi.airobots.bonsai.core.CoreObjectFactory.CoreObjectCreationException;
import de.unibi.airobots.bonsai.core.Sensor;
import de.unibi.airobots.bonsai.core.configuration.ConfigurationParser;
import de.unibi.airobots.bonsai.core.configuration.ConfiguredActuator;
import de.unibi.airobots.bonsai.core.configuration.ConfiguredSensor;

/**
 * @author nkoester
 */
public class SCXMLSensorActuatorManager {

    private HashMap<String, ? extends Actuator > actuatorMap =
            new HashMap<String, Actuator >();

    private HashMap<String, Sensor<?>> sensorMap = new HashMap<String, Sensor<?>>();

    private static final Logger LOGGER = Logger
            .getLogger(SCXMLSensorActuatorManager.class);

    /**
     * Convenience Constructor.
     */
    public SCXMLSensorActuatorManager(String pathToSCXML,
            String pathToBonsaiConfigXML) {

        /*
        try {
            
            ConfigurationParser parser = 
                    BonsaiManager.getInstance().configure(
                            SkillStateMachine.class.getResource(
                                    pathToBonsaiConfigXML).toURI());
            LOGGER.debug("Bonsai Config XML found.");

            Set<ConfiguredSensor> sensorSet = parser.getConfiguredSensors();
            Set<ConfiguredActuator> actuatorSet =
                    parser.getConfiguredActuators();
            LOGGER.debug("Before loops");
            
            for (ConfiguredSensor configuredSensor : sensorSet) {
                try {
                    LOGGER.debug("Loading and adding sensor: "+ configuredSensor.getSensorClassName());
                    sensorMap.put(
                            configuredSensor.getSensorClassName(),
                            BonsaiManager.getInstance().createSensor(
                                    configuredSensor.getSensorClassName(),
                                    Class.forName(configuredSensor
                                            .getDataTypeClassName())));
                } catch (IllegalArgumentException e) {
                    LOGGER.fatal("Bonsai sensor creation error: "
                            + e.getMessage());
                } catch (CoreObjectCreationException e) {
                    LOGGER.fatal("Bonsai sensor creation error: "
                            + e.getMessage());
                } catch (ClassNotFoundException e) {
                    LOGGER.fatal("Bonsai sensor creation error: "
                            + e.getMessage());
                }
            }

            for (ConfiguredActuator configuredActuator : actuatorSet) {
                try {
                    LOGGER.debug("Loading and adding sensor: "+ configuredActuator.getActuatorClassName());
                    sensorMap.put(
                            configuredActuator.getActuatorClassName(),
                            BonsaiManager.getInstance().createSensor(
                                    configuredActuator.getActuatorClassName(),
                                    Class.forName(configuredActuator.getActuatorClassName())));
                } catch (IllegalArgumentException e) {
                    LOGGER.fatal("Bonsai actuator creation error: "
                            + e.getMessage());
                } catch (CoreObjectCreationException e) {
                    LOGGER.fatal("Bonsai actuator creation error: "
                            + e.getMessage());
                } catch (ClassNotFoundException e) {
                    LOGGER.fatal("Bonsai actuator creation error: "
                            + e.getMessage());
                }
            }
            

        } catch (IllegalStateException e) {
            LOGGER.fatal("Bonsai Config XML error: " + e.getMessage());
            System.exit(-666);
        } catch (ConfigurationException e) {
            LOGGER.fatal("Bonsai Config XML parse error: " + e.getMessage());
            System.exit(-666);
        } catch (URISyntaxException e) {
            LOGGER.fatal("Bonsai Config XML uri-syntax error: "
                    + e.getMessage());
            System.exit(-666);
        }
        */
    }

    /**
     * Returns a reference to an actuator (if present) or creates a new one with
     * the BonSAI manager.
     * 
     * @param actuatorName
     * @param aDataType
     * @return
     */
    public <T extends Actuator> T getManagedActuator(String actuatorName, Class<T> aDataTypeClass) {

        // TODO: add check if sensor/actuator still there != null, bonsai manager reconnect?
        
//        if (actuatorMap.containsKey(actuatorName)) {
//            actuatorMap.get(actuatorName);
//        } else {
//            actuatorMap.put(actuatorName, BonsaiManager.getInstance()
//                    .createActuator(actuatorName, aDataTypeClass));
//        }
        //TODO: FIX CAST!!!
        return (T) actuatorMap.get(actuatorName);
    }

    /**
     * Returns a reference to a sensor (if present) or creates a new one with
     * the BonSAI manager.
     * 
     * @param sensorName
     * @param aDataType
     * @return
     */
    public <T> Sensor<T> getManagedSensor(String sensorName, Class<T> aDataTypeClass) {

//        if (sensorMap.containsKey(sensorName)) {
//            sensorMap.get(sensorName);
//        } else {
//            sensorMap.put(
//                    sensorName,
//                    BonsaiManager.getInstance().createSensor(sensorName,
//                            aDataTypeClass));
//        }
        //TODO: FIX CAST!!!
        return (Sensor<T>) sensorMap.get(sensorName);
    }

}
