/**
 * 
 */
package de.unibi.airobots.bonsai.skills;

import java.util.Iterator;
import java.util.Map;

import org.apache.commons.scxml.model.SCXML;
import org.apache.commons.scxml.model.State;
import org.apache.log4j.Logger;

/**
 * Class containing methods for SCXML validation.
 * 
 * @author nkoester
 */
public class SCXMLValidator {

    /**
     * Constructor.
     */
    public SCXMLValidator() {
        // nothing yet
    }

    /**
     * The log.
     */
    private static final Logger LOG = Logger.getLogger(SCXMLValidator.class);

    /**
     * Validates a given SCXML based on the availability of the named skill
     * states.
     * 
     * @param aSCXML
     *            a already pased and decoded SCXML
     * @return true for a validate SCXML; false for an invalidate SCXML
     */
    public boolean validateSCXML(SCXML aSCXML) {

        
            Map<?, State> m;
            m = aSCXML.getChildren();
            Iterator<State> it = m.values().iterator();

            while (it.hasNext()) {
                State aChild = it.next();
                String aChildName = aChild.getId();

                try {
                    Class<?> c =
                            Class.forName("de.unibi.airobots.bonsai.skills.state."
                                    + aChildName);

                    if (!c.equals(null)) {
                        System.out.println("Found state: " + aChildName);

                        // TODO: check if transition between states is legal

                        // Constructor<AbstractState> ct =
                        // (Constructor<AbstractState>) c.getConstructor();
                        // AbstractState stateObject = ct.newInstance();
                        // stateChain.add(stateObject);

                    }
                } catch (Exception e) {
                    // pokemon exception catching ftw
                    LOG.error("State " + aChildName
                            + " was not found! Terminating: " + e.getMessage());
                    System.exit(-1);
                    return false;
                }
            }

            // TODO: finding the specified actuators/sensors by using the bonsai
            // config xml or so ...
            // validateActuatorSensorList()
            LOG.info("Parsing and validation complete.");
            return true;
//            LOG.error("State definitions are invalid. Check the SCXML mate!");

    }
}
