package de.unibi.airobots.bonsai.util.arm;

import java.util.Vector;
import java.lang.Math;

import de.unibi.airobots.btl.data.KatanaPoseData;

public class KatanaPoseDirectionCalculator {

    public static Vector<Double> calcluateDirection(KatanaPoseData startPose,
            KatanaPoseData targetPose) {
        Vector<Double> ret = new Vector<Double>();

        double destX = targetPose.getX() - startPose.getX();
        double destY = targetPose.getY() - startPose.getY();
        double destZ = targetPose.getZ() - startPose.getZ();

        double length =
                Math.sqrt(Math.pow(destX, 2) + Math.pow(destY, 2)
                        + Math.pow(destZ, 2));

        ret.add(destX / length);
        ret.add(destY / length);
        ret.add(destZ / length);

        return ret;
    }
}
