/*
* This file is part of Bielefeld Sensor Actuator Interface (BonSAI).
*
* Copyright(c) Frederic Siepmann
* http://opensource.cit-ec.de/projects/bonsai
*
* This file may be licensed under the terms of of the
* GNU Lesser General Public License Version 3 (the ``LGPL''),
* or (at your option) any later version.
*
* Software distributed under the License is distributed
* on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
* express or implied. See the LGPL for the specific language
* governing rights and limitations.
*
* You should have received a copy of the LGPL along with this
* program. If not, go to http://www.gnu.org/licenses/lgpl.html
* or write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*
* The development of this software was supported by the
* Excellence Cluster EXC 277 Cognitive Interaction Technology.
* The Excellence Cluster EXC 277 is a grant of the Deutsche
* Forschungsgemeinschaft (DFG) in the context of the German
* Excellence Initiative.
*
* Contributors: Leon Ziegler, Johannes Wienke, Norman Köster, Torben Töniges,
* 				Annika Rothert, Alexander Baumann, Marcel Dulisch, Maikel Linke,
* 				Marian Pohling, Lukas Twardon
*/
package de.unibi.airobots.bonsai.yarp;

import yarp.Bottle;
import yarp.Time;


import java.util.Map;
import java.util.HashMap;
import yarp.Port;

/**
 *
 * @author cdondrup
 */
public class Example1 {

    public static void main(String[] args) {
        YarpFactory yf = new YarpFactory();
        Map<String, String> options = new HashMap<String, String>();
        options.put(YarpFactory.OPTION_LIBRARY_TO_LOAD, "libjyarp");
        yf.initialize(options);
//	Port p = new Port();
//	p.open("/foo");
//	// connect to a port called "/bar" if present
//	Network.connect("/foo","/bar");
        PortReconnectableManager<Port> prm = new PortReconnectableManager();
        Example1PortReconnectable<Port> epr = new Example1PortReconnectable();
        prm.initializeAndManage(Port.class, epr);
        
        while (true) {
            Bottle bot = new Bottle();
            bot.addDouble(10.4);
            bot.addString("bozo");
            System.out.println("sending bottle: " + bot);
            prm.getPortByName(epr.getPortName()).getPort().write(bot);
            Time.delay(1);
        }
        //Network.fini(); // never reached
    }
}
